//const dout=Components.utils.reportError;
var returnResult = true;

const ACR = Components.interfaces.nsIAutoCompleteResult;

// This result can't be constructed in-line, because otherwise we leak memory.
function nsAutoCompleteSimpleResult(aString)
{
  this.searchString = aString;
  if (returnResult) {
    this.searchResult = ACR.RESULT_SUCCESS;
    this.matchCount = 1;
    this._param = "Result";
  }
}

nsAutoCompleteSimpleResult.prototype = {
 _param: "",
 searchString: null,
 searchResult: ACR.RESULT_FAILURE,
 defaultIndex: 0,
 errorDescription: null,
 matchCount: 0,
 getValueAt: function() { return this._param; },
 getCommentAt: function() { return null; },
 getStyleAt: function() { return null; },
 getImageAt: function() { return null; },
 removeValueAt: function() {},
 
 QueryInterface: function(aIID)
    {
        if (!aIID.equals(Ci.nsIAutoCompleteResult) &&
            !aIID.equals(Ci.nsISupports))
            throw Components.results.NS_ERROR_NO_INTERFACE;

        return this;
    }
 
};

// A basic autocomplete implementation that either returns one result or none
var autoCompleteSimpleID = Components.ID("{0a2afbdb-f30e-47d1-9cb1-0cd160240aca}");
var autoCompleteSimpleName = "@mozilla.org/autocomplete/search;1?name=simple";
var autoCompleteSimple = {
  QueryInterface: function(iid) {
    if (iid.equals(Components.interfaces.nsISupports) ||
//        iid.equals(Components.interfaces.nsIFactory) ||
        iid.equals(Components.interfaces.nsIAutoCompleteSearch))
      return this;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  createInstance: function(outer, iid) {
    return this.QueryInterface(iid);
  },

  startSearch: function(aString, aParam, aResult, aListener) {
    var result = new nsAutoCompleteSimpleResult(aString);
    aListener.onSearchResult(this, result);
  },

  stopSearch: function() {}
};
/*
var componentManager = Components.manager
                                 .QueryInterface(Components.interfaces.nsIComponentRegistrar);
componentManager.registerFactory(autoCompleteSimpleID, "Test Simple Autocomplete",
                                 autoCompleteSimpleName, autoCompleteSimple);
*/
                                 
  Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

var component = [autoCompleteSimple];
var NSGetFactory = XPCOMUtils.generateNSGetFactory(component);

/*
dlog("Test111");


////////////////for debug//////////////////////////////////
function dlog(str){
  dout(str);
  var name="log.txt";
  str=new Date()+"\t"+str.replace(/\r/g,"\\r").replace(/\n/g,"\\n")+"\r\n";
  saveFile(name,str,this.notFirst);
  this.notFirst=true;
}
///////////////////////////////////////////////////////////
function saveFile(name,str,append){
  var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
  name=name.split("/");
  for(var i in name){
    file.append(name[i]);
    if(i<name.length-1){
      if(!file.exists()){
        file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0755);
      }
    }
  }
  return saveFile0(file,str,append);
}
function saveFile0(file,str,append){
  try{
    var fos = Components.classes["@mozilla.org/network/file-output-stream;1"]
                          .createInstance(Components.interfaces.nsIFileOutputStream);
    fos.init(file, 0x02 | 0x08 |(append?0x10:0x20), 0664, 0);
    var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
                       .createInstance(Components.interfaces.nsIConverterOutputStream);
    os.init(fos, "UTF-8", 0, 0x0000);
    os.writeString(str);
    os.close();
    fos.close();
  }catch(e){
dout(e);
  }
  return file;
}
*/